--- /usr/bin/cygport.orig	2008-08-26 23:07:26.001000000 -0400
+++ /usr/bin/cygport	2008-08-27 14:05:15.604873700 -0400
@@ -728,6 +728,11 @@
 	fi
 }
 
+# provides a hook for cygclasses/cygports to take action
+# *after* origsrc directory is mirrored to src directory
+src_prep_fini_hook() {
+	:
+}
 __src_prep() {
 	local sigext;
 	local src_patch;
@@ -827,10 +832,15 @@
 	then
 		cygpatch ${top}/${cygwin_patchfile} ${top}/${src_patchfile};
 	fi
+
+	cd ${top}
+	src_prep_fini_hook
+	cd ${S}
 }
 
 # protect functions
 readonly -f fetch __mirror_fetch __src_fetch unpack __gpg_verify __mkdirs cygpatch __oldpatch __src_prep
+export -f src_prep_fini_hook
 
 
 ################################################################################
@@ -1292,6 +1302,7 @@
 
 # Pre-install steps
 __prepinstalldirs() {
+	src_install_init_hook;
 	rm -fr ${D}/*;
 
 	# circumvent pointless libtool relinking during install
@@ -1342,8 +1353,21 @@
 	cyginstall
 }
 
+# provides a hook for cygclasses/cygports to take action
+# *before* built-in preinstall steps.
+src_install_init_hook() {
+	:
+}
+
+# provides a hook for cygclasses/cygports to take action
+# *after* built-in postinstall steps.
+src_install_fini_hook() {
+	:
+}
+
 # protect functions
 export -f dodir keepdir docinto exeinto insinto
+export -f src_install_init_hook src_install_fini_hook
 readonly -f dodir keepdir docinto exeinto insinto __prepinstalldirs cyginstall
 
 
@@ -1680,6 +1704,7 @@
 	__prep_empty_dirs;
 	__prepstrip;
 	__prep_libtool_modules;
+	src_install_fini_hook;
 }
 
 # protect functions
